import { __awaiter } from 'tslib';
import { TestBed } from '@angular/core/testing';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/base-test.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const resetTestingModule = TestBed.resetTestingModule;
/** @type {?} */
const preventAngularFromResetting = (/**
 * @return {?}
 */
() => TestBed.resetTestingModule = (/**
 * @return {?}
 */
() => TestBed));
const ɵ0 = preventAngularFromResetting;
/** @type {?} */
const allowAngularToReset = (/**
 * @return {?}
 */
() => TestBed.resetTestingModule = resetTestingModule);
const ɵ1 = allowAngularToReset;
// @dynamic
class BaseTest {
}
/**
 * TestBed configuration with single setup option.
 */
BaseTest.setupTestBed = (/**
 * @param {?} moduleDef
 * @return {?}
 */
(moduleDef) => {
    // @ts-ignore
    beforeAll((/**
     * @param {?} done
     * @return {?}
     */
    done => ((/**
     * @return {?}
     */
    () => __awaiter(this, void 0, void 0, function* () {
        resetTestingModule();
        preventAngularFromResetting();
        TestBed.configureTestingModule(moduleDef);
        yield TestBed.compileComponents();
        TestBed.resetTestingModule = (/**
         * @return {?}
         */
        () => TestBed);
    })))().then(done)
        .catch(done.fail)));
    // @ts-ignore
    afterAll((/**
     * @return {?}
     */
    () => allowAngularToReset()));
});
if (false) {
    /**
     * TestBed configuration with single setup option.
     * @type {?}
     */
    BaseTest.setupTestBed;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/event-options.const.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Button event options
 * @type {?}
 */
const ButtonClickEvents = {
    left: { button: 0 },
    right: { button: 1 }
};
/**
 * Scroll event options
 * @type {?}
 */
const ScrollEvents = {
    scrollDown: {
        target: {
            scrollHeight: 100,
            scrollTop: 100,
            offsetHeight: 0
        }
    }
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/event-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EventHandler {
    /**
     * Simulate element single click.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    static click(element, eventObj = ButtonClickEvents.left) {
        element instanceof HTMLElement
            ? element.click()
            : element.triggerEventHandler('click', eventObj);
    }
    /**
     * Simulate element dblclick.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    static dblclick(element, eventObj = ButtonClickEvents.left) {
        element instanceof HTMLElement
            ? element.ondblclick(new MouseEvent('event'))
            : element.triggerEventHandler('dblclick', eventObj);
    }
    /**
     * Simulate element scroll via mousewheel.
     * Default option is scroll down event.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    static scroll(element, eventObj = ScrollEvents.scrollDown) {
        element instanceof HTMLElement
            ? element.scroll()
            : element.triggerEventHandler('scroll', eventObj);
    }
    /**
     * Simulate form submit.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    static submit(element, eventObj = ButtonClickEvents.left) {
        element instanceof HTMLFormElement
            ? element.submit()
            : element.triggerEventHandler('submit', eventObj);
    }
    /**
     * Simulate element focus
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    static focus(element, eventObj = {}) {
        element.triggerEventHandler('focus', eventObj);
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: godeltech-angular-testing.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BaseTest, ButtonClickEvents, EventHandler, ScrollEvents };
//# sourceMappingURL=godeltech-angular-testing.js.map
