import { __awaiter, __generator } from 'tslib';
import { TestBed } from '@angular/core/testing';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/base-test.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var _this = this;
/** @type {?} */
var resetTestingModule = TestBed.resetTestingModule;
/** @type {?} */
var preventAngularFromResetting = (/**
 * @return {?}
 */
function () { return TestBed.resetTestingModule = (/**
 * @return {?}
 */
function () { return TestBed; }); });
var ɵ0 = preventAngularFromResetting;
/** @type {?} */
var allowAngularToReset = (/**
 * @return {?}
 */
function () { return TestBed.resetTestingModule = resetTestingModule; });
var ɵ1 = allowAngularToReset;
// @dynamic
var BaseTest = /** @class */ (function () {
    function BaseTest() {
    }
    /**
     * TestBed configuration with single setup option.
     */
    BaseTest.setupTestBed = (/**
     * @param {?} moduleDef
     * @return {?}
     */
    function (moduleDef) {
        // @ts-ignore
        beforeAll((/**
         * @param {?} done
         * @return {?}
         */
        function (done) {
            return ((/**
             * @return {?}
             */
            function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            resetTestingModule();
                            preventAngularFromResetting();
                            TestBed.configureTestingModule(moduleDef);
                            return [4 /*yield*/, TestBed.compileComponents()];
                        case 1:
                            _a.sent();
                            TestBed.resetTestingModule = (/**
                             * @return {?}
                             */
                            function () { return TestBed; });
                            return [2 /*return*/];
                    }
                });
            }); }))().then(done)
                .catch(done.fail);
        }));
        // @ts-ignore
        afterAll((/**
         * @return {?}
         */
        function () { return allowAngularToReset(); }));
    });
    return BaseTest;
}());
if (false) {
    /**
     * TestBed configuration with single setup option.
     * @type {?}
     */
    BaseTest.setupTestBed;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/event-options.const.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Button event options
 * @type {?}
 */
var ButtonClickEvents = {
    left: { button: 0 },
    right: { button: 1 }
};
/**
 * Scroll event options
 * @type {?}
 */
var ScrollEvents = {
    scrollDown: {
        target: {
            scrollHeight: 100,
            scrollTop: 100,
            offsetHeight: 0
        }
    }
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/event-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EventHandler = /** @class */ (function () {
    function EventHandler() {
    }
    /**
     * Simulate element single click.
     * Default option is mouse left-button event click.
     * @param element Target element.
     * @param eventObj Event option.
     */
    /**
     * Simulate element single click.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    EventHandler.click = /**
     * Simulate element single click.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    function (element, eventObj) {
        if (eventObj === void 0) { eventObj = ButtonClickEvents.left; }
        element instanceof HTMLElement
            ? element.click()
            : element.triggerEventHandler('click', eventObj);
    };
    /**
     * Simulate element dblclick.
     * Default option is mouse left-button event click.
     * @param element Target element.
     * @param eventObj Event option.
     */
    /**
     * Simulate element dblclick.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    EventHandler.dblclick = /**
     * Simulate element dblclick.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    function (element, eventObj) {
        if (eventObj === void 0) { eventObj = ButtonClickEvents.left; }
        element instanceof HTMLElement
            ? element.ondblclick(new MouseEvent('event'))
            : element.triggerEventHandler('dblclick', eventObj);
    };
    /**
     * Simulate element scroll via mousewheel.
     * Default option is scroll down event.
     * @param element Target element.
     * @param eventObj Event option.
     */
    /**
     * Simulate element scroll via mousewheel.
     * Default option is scroll down event.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    EventHandler.scroll = /**
     * Simulate element scroll via mousewheel.
     * Default option is scroll down event.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    function (element, eventObj) {
        if (eventObj === void 0) { eventObj = ScrollEvents.scrollDown; }
        element instanceof HTMLElement
            ? element.scroll()
            : element.triggerEventHandler('scroll', eventObj);
    };
    /**
     * Simulate form submit.
     * Default option is mouse left-button event click.
     * @param element Target element.
     * @param eventObj Event option.
     */
    /**
     * Simulate form submit.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    EventHandler.submit = /**
     * Simulate form submit.
     * Default option is mouse left-button event click.
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    function (element, eventObj) {
        if (eventObj === void 0) { eventObj = ButtonClickEvents.left; }
        element instanceof HTMLFormElement
            ? element.submit()
            : element.triggerEventHandler('submit', eventObj);
    };
    /**
     * Simulate element focus
     * @param element Target element.
     * @param eventObj Event option.
     */
    /**
     * Simulate element focus
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    EventHandler.focus = /**
     * Simulate element focus
     * @param {?} element Target element.
     * @param {?=} eventObj Event option.
     * @return {?}
     */
    function (element, eventObj) {
        if (eventObj === void 0) { eventObj = {}; }
        element.triggerEventHandler('focus', eventObj);
    };
    return EventHandler;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: godeltech-angular-testing.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BaseTest, ButtonClickEvents, EventHandler, ScrollEvents };
//# sourceMappingURL=godeltech-angular-testing.js.map
