import { DebugElement } from '@angular/core';
export declare class EventHandler {
    /**
     * Simulate element single click.
     * Default option is mouse left-button event click.
     * @param element Target element.
     * @param eventObj Event option.
     */
    static click(element: DebugElement | HTMLElement, eventObj?: any): void;
    /**
     * Simulate element dblclick.
     * Default option is mouse left-button event click.
     * @param element Target element.
     * @param eventObj Event option.
     */
    static dblclick(element: DebugElement | HTMLElement, eventObj?: any): void;
    /**
     * Simulate element scroll via mousewheel.
     * Default option is scroll down event.
     * @param element Target element.
     * @param eventObj Event option.
     */
    static scroll(element: DebugElement | HTMLElement, eventObj?: any): void;
    /**
     * Simulate form submit.
     * Default option is mouse left-button event click.
     * @param element Target element.
     * @param eventObj Event option.
     */
    static submit(element: DebugElement | HTMLFormElement, eventObj?: any): void;
    /**
     * Simulate element focus
     * @param element Target element.
     * @param eventObj Event option.
     */
    static focus(element: DebugElement, eventObj?: any): void;
}
